# coding: utf-8

"""
    User Service API

    Solomon AI User Service API - Manages user profiles and authentication

    The version of the OpenAPI document: 1.0
    Contact: yoanyomba@solomon-ai.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from solomonai_backend_client_sdk.models.comment1 import Comment1
from solomonai_backend_client_sdk.models.comment_edit import CommentEdit
from typing import Optional, Set
from typing_extensions import Self

class GetCommentResponse(BaseModel):
    """
    GetCommentResponse
    """ # noqa: E501
    comment: Optional[Comment1] = None
    reactions: Optional[Dict[str, StrictInt]] = None
    edit_history: Optional[List[CommentEdit]] = Field(default=None, alias="editHistory")
    __properties: ClassVar[List[str]] = ["comment", "reactions", "editHistory"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetCommentResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of comment
        if self.comment:
            _dict['comment'] = self.comment.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in edit_history (list)
        _items = []
        if self.edit_history:
            for _item in self.edit_history:
                if _item:
                    _items.append(_item.to_dict())
            _dict['editHistory'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetCommentResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "comment": Comment1.from_dict(obj["comment"]) if obj.get("comment") is not None else None,
            "reactions": obj.get("reactions"),
            "editHistory": [CommentEdit.from_dict(_item) for _item in obj["editHistory"]] if obj.get("editHistory") is not None else None
        })
        return _obj


